;;;*****************************************************************************************;;;;;;
;;;UP JB_dez_hex => Es wird eine Dezimalzahl in eine Hexadezimalzahl ausgegeben               ;;;;
;;;*****************************************************************************************;;;;;;
;;;INPUT Dezimahlzahl als INTEGER
;;;OUTPUT Hexa als STRING
(defun JB_dez_hex (dez / binaer_liste Hexa_Liste expt_n expt_n1 expt_liste  n hex nybble)
  (setq Hexa_Liste (list "0" "1" "2" "3" "4" "5" "6" "7" "8" "9" "A" "B" "C" "D" "E" "F")
	binaer_liste(list "0000" "0001" "0010" "0011"
	                  "0100" "0101" "0110" "0111"
	                  "1000" "1001" "1010" "1011"
	                  "1100" "1101" "1110" "1111")
	expt_n1 4)
  (setq expt_n (JB_expt_n 0 dez))
  (if (= expt_n 0)
    (setq expt_n1 4
	  expt_liste (list 0 0 0 0 0))
    (progn
    (while (< expt_n1 expt_n)
      (setq expt_n1 (+ expt_n1 4)))
    (repeat (+ expt_n1 1)
      (if (<=(expt 2 expt_n1)dez)
	(setq expt_liste (JB_write_ls1 expt_liste 1)
	      dez (- dez (expt 2 expt_n1)))
	(setq expt_liste (JB_write_ls1 expt_liste 0)))
      (setq expt_n1 (- expt_n1 1)))))
  (if expt_liste
  (setq expt_liste (cdr(reverse expt_liste))))
  (setq n 0)
  (repeat (/(length expt_liste)4)
    (if (setq nybble (member(strcat (itoa(nth n expt_liste))(itoa(nth (+ n 1) expt_liste))
				    (itoa(nth (+ n 2) expt_liste))(itoa(nth (+ n 3) expt_liste)))binaer_liste))
      (if hex
	(setq hex(strcat hex(nth (- (length Hexa_Liste)(length nybble))Hexa_Liste)))
	(setq hex(nth (- (length Hexa_Liste)(length nybble))Hexa_Liste))))
    (setq n (+ n 4)))
    hex)
;;; das n fr Exponenzialzahl zurckgeben Wert = 2
(defun JB_expt_n (n dez / )
  (while (<=(expt 2 n)dez)
    (setq n (+ n 1)))n)

;;;*****************************************************************************************;;;;;;
;;;UP JB_hex_dez => Es wird eine Hexadezimalzahl in eine Integer-Dezimalzahl ausgegeben       ;;;;
;;;*****************************************************************************************;;;;;;
;;;INPUT Hexa als STRING
;;;OUTPUT Dezimalzahl als INTGER
(defun JB_hex_dez (hex / Hexa_Liste hex_bit Hex_n Hex_strlen dezi_liste)
  (setq Hexa_Liste (list "0" "1" "2" "3" "4" "5" "6" "7" "8" "9" "A" "B" "C" "D" "E" "F")
	Hex_strlen (strlen hex))
  (repeat (strlen hex)
    (setq hex_bit (strcase(substr hex 1 1))
	  hex (substr hex 2))
    (if (setq Hex_n(member hex_bit Hexa_Liste))
        (setq dezi_liste (JB_write_ls1 dezi_liste
			 (* (-(length Hexa_Liste)(length Hex_n)) (expt 16 (- Hex_strlen (- Hex_strlen (strlen hex)))))))
      (JB_exit (strcat "\n"hex_bit " ist kein gltiges Hexadezimalzeichen."))))
 (if dezi_liste
  (apply '+ dezi_liste)))

(defun JB_write_ls1 (lsname lselement / )
(if lsname
	    (setq lsname (cons lselement lsname))
	    (setq lsname (list lselement))))

(defun rgb_farbe (layer / gc420 hex r g b)
  (if (tblsearch "LAYER" layer)
    (if (setq gc420(assoc 420(entget(tblobjname "LAYER" layer))))
      (progn
	(setq hex(JB_dez_hex (cdr gc420)))
        (while (<(strlen hex)6)
	 (setq hex (strcat "0" hex)))
        (setq r (itoa(JB_hex_dez(substr hex 1 2)))
	      g (itoa(JB_hex_dez(substr hex 3 2)))
	      b (itoa(JB_hex_dez(substr hex 5 2))))
	(princ (strcat "\nR=" r " G=" g " B="b)))
      (alert (strcat "Dem Layer \"" layer "\" wurde keine RGB-Farbe zugewiesen.")))
    (alert (strcat "Der Layer \"" layer "\" existiert nicht.")))
  (princ)
  )
    
	
      